#!/home/fsf/sun_solaris/bin/python

from Tkinter import *


## CLASSE ROUND.SQUARE.FRAME:
## ==========================
# Cadre avec une bordure rectangulaire a bords arrondis autour

class RoundSquareFrame(Frame):

  ## ATTRIBUTS DE CLASSE:
  ## --------------------
  cornerRadius = 12  # Rayon pour le coin
  

  ## METHODE __INIT__:
  ## -----------------
  # Cree une instance de la classe
  
  def __init__(self, parent=None, config={}, **params):
    ## Fusion des options de config.
    configDict = config
    for k in params.keys(): configDict[k] = params[k]
    ## Recuperation des options de couleurs
    self.bgColor = ''
    if configDict.has_key('bg'): self.bgColor = configDict['bg']
    if configDict.has_key('background'): self.bgColor = configDict['background']
    ## (en passant: le frame n'accepte pas de couleur d'avant-plan => on la vire)
    self.fgColor = ''
    if configDict.has_key('fg'):
      self.fgColor = configDict['fg']
      del configDict['fg']
    if configDict.has_key('foreground'):
      self.fgColor = configDict['foreground']
      del configDict['foreground']
    ## Creation du cadre externe
    self.outerFrame = Frame(parent, configDict)
    ## Configuration de la grille du cadre externe
    self.outerFrame.grid_rowconfigure(1, weight=1, pad=0)
    self.outerFrame.grid_columnconfigure(1, weight=1, pad=0)
    ## Recuperation du rayon pour le coin
    r = RoundSquareFrame.cornerRadius
    ## Creation du coin rond haut-gauche
    ulCanvas = Canvas(self.outerFrame, bg=self.bgColor, bd=0, highlightthickness=0, width=r, height=r)
    ulCanvas.create_arc(1, 1, 2*r + 1, 2*r + 1, start=90, extent=90, outline=self.fgColor, width=3)
    ulCanvas.grid(row=0, column=0)
    ## Creation du coin bas-gauche
    llCanvas = Canvas(self.outerFrame, bg=self.bgColor, bd=0, highlightthickness=0, width=r, height=r)
    llCanvas.create_arc(1, -2 - r, 2*r + 1, r - 2, start=180, extent=90, outline=self.fgColor, width=3)
    llCanvas.grid(row=2, column=0)
    ## Creation du coin haut-droit
    urCanvas = Canvas(self.outerFrame, bg=self.bgColor, bd=0, highlightthickness=0, width=r, height=r)
    urCanvas.create_arc(-2 - r, 1, r - 2, 2*r + 1, start=0, extent=90, outline=self.fgColor, width=3)
    urCanvas.grid(row=0, column=2)
    ## Creation du coin bas-droit
    lrCanvas = Canvas(self.outerFrame, bg=self.bgColor, bd=0, highlightthickness=0, width=r, height=r)
    lrCanvas.create_arc(-2 - r, -2 - r, r - 2, r - 2, start=-90, extent=90, outline=self.fgColor, width=3)
    lrCanvas.grid(row=2, column=2)
    ## Creation des cotes
    nSide = Frame(self.outerFrame, bg=self.fgColor, bd=2, height=3)
    nSide.grid(row=0, column=1, sticky='nwe')
    wSide = Frame(self.outerFrame, bg=self.fgColor, bd=2, width=3)
    wSide.grid(row=1, column=0, sticky='nws')
    sSide = Frame(self.outerFrame, bg=self.fgColor, bd=2, height=3)
    sSide.grid(row=2, column=1, sticky='swe')
    eSide = Frame(self.outerFrame, bg=self.fgColor, bd=2, width=3)
    eSide.grid(row=1, column=2, sticky='nes')
    ## Creation du cadre interne = objet courant
    Frame.__init__(self, self.outerFrame, configDict)
    ## Placement dans le cadre externe
    Frame.grid(self, row=1, column=1, sticky='nswe')
    
    
  ## METHODE PACK:
  ## -------------
  # La methode doit s'appeler sur le cadre externe et non sur l'objet courant
  
  def pack(self, config={}, **kw):
    ## Fusion des options
    for k in kw.keys(): config[k] = kw[k]
    ## Appel de la methode de la super-classe sur le cadre externe
    self.outerFrame.pack(config)


  ## METHODE GRID:
  ## -------------
  # La methode doit s'appeler sur le cadre externe et non sur l'objet courant
  
  def grid(self, config={}, **kw):
    ## Fusion des options
    for k in kw.keys(): config[k] = kw[k]
    ## Appel de la methode de la super-classe sur le cadre externe
    self.outerFrame.grid(config)
