from Tkinter import *


## CLASSE SLIDER:
## ==============
# Curseur

class Slider:

  ## METHODE __INIT__:
  ## -----------------
  
  def __init__(self, parent, startVal, endVal, config={}, **params):
    ## Fusion des parametres de config.
    for k in params.keys(): config[k] = params[k]
    ## Extraction des parametres "interessants"
    bgColor = None
    if config.has_key('bg'): bgColor = config['bg']
    if config.has_key('backgound'): bgColor = config['backgound']
    fgColor = None
    if config.has_key('fg'): fgColor = config['fg']
    if config.has_key('foregound'): fgColor = config['foregound']
    var = ''
    if config.has_key('variable'): var = config['variable']
    if var <> '': val = var.get()
    ## Orientation
    orient=HORIZONTAL
    packSide = LEFT
    if config.has_key('orient'): orient = config['orient']
    ## Si vertical, on inverse les valeurs start et end, sinon le curseur descend...
    if orient == VERTICAL:
      packSide = TOP
      startVal, endVal = endVal, startVal
    ## Creation du cadre englobant
    self.frm = Frame(parent, bg=bgColor)
    ## Creation du curseur
    self.scale = Scale(self.frm, showvalue=0, orient=orient, bd=0, variable=var)
    if fgColor <> None: self.scale['fg'] = fgColor
    if bgColor <> None: self.scale['bg'] = bgColor
    self.scale['from'] = startVal
    self.scale['to'] = endVal
    ## Dimensions
    self.width = self.scale.winfo_reqwidth()
    self.height = self.scale.winfo_reqheight()
    ## On fixe les parametres
    if config.has_key('resolution'): self.scale['resolution'] = config['resolution']
    if config.has_key('digits'): self.scale['digits'] = config['digits']
    if config.has_key('troughcolor'): self.scale['troughcolor'] = config['troughcolor']
    if config.has_key('activebackground'): self.scale['activebackground'] = config['activebackground']
    ## Et on packe
    self.scale.pack(side=packSide)
    ## Entree
    ent = Entry(self.frm, relief=FLAT, textvariable=var, \
                insertbackground='white', selectbackground='white')
    if fgColor <> None: ent['fg'] = fgColor
    if bgColor <> None: ent['bg'] = bgColor
    if config.has_key('width'): ent['width'] = config['width']
    if config.has_key('font'): ent['font'] = config['font']
    ent.pack(side=packSide)
    ## Largeur
    if orient == VERTICAL: self.width = 0
    if orient == HORIZONTAL: self.height = 0
    self.width = self.width + ent.winfo_reqwidth()
    self.height = self.height + ent.winfo_reqheight()
    ## On re-fixe la valeur initiale pour cause de bug...
    if var <> '': var.set(val)
    
    
  ## METHODE WINFO_REQWIDTH:
  ## -----------------------
  # Rend la largeur du slider
  
  def winfo_reqwidth(self):
    return self.width
    
    
  ## METHODE WINFO_REQHEIGHT:
  ## -----------------------
  # Rend la hauteur du slider
  
  def winfo_reqheight(self):
    return self.height
    
    
  ## METHODE PACK:
  ## -------------
  # La methode s'applique au cadre englobant
  
  def pack(self, config={}, **kw):
    for k in kw.keys(): config[k] = kw[k]
    self.frm.pack(config)
    
    
  ## METHODE GRID:
  ## -------------
  # La methode s'applique au cadre englobant
  
  def grid(self, config={}, **kw):
    for k in kw.keys(): config[k] = kw[k]
    self.frm.grid(config)
  
  
  ## METHODE SET.FROM:
  ## -----------------
  # Fixe la borne inferieure pour le slider
  
  def setFrom(self, fromValue):
    self.scale['from'] = fromValue
  
  
  ## METHODE SET.TO:
  ## ---------------
  # Fixe la borne superieure pour le slider
  
  def setTo(self, toValue):
    self.scale['to'] = toValue


## CLASSE HORIZ.SLIDER:
## ====================
# Curseur horizontal

class HorizSlider(Slider):

  ## METHODE __INIT__:
  ## -----------------
  
  def __init__(self, parent, startVal, endVal, config={}, **params):
    ## Fusion des parametres de config.
    for k in params.keys(): config[k] = params[k]
    ## Initialisation en forcant l'orientation
    config['orient'] = HORIZONTAL
    Slider.__init__(self, parent, startVal, endVal, config)
    


## CLASSE VERT.SLIDER:
## ===================
# Curseur vertical

class VertSlider(Slider):

  ## METHODE __INIT__:
  ## -----------------
  
  def __init__(self, parent, startVal, endVal, config={}, **params):
    ## Fusion des parametres de config.
    for k in params.keys(): config[k] = params[k]
    ## Initialisation en forcant l'orientation
    config['orient'] = VERTICAL
    Slider.__init__(self, parent, startVal, endVal, config)
    
    
